// MV2Command_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MV2Command_VC.h"
#include "MV2Command_VCDlg.h"

#include "mv2commands.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


struct TMV2Command 
{
  int ID;
  char* cDesc;
};


//
//
// SendCommand
//
//

const TMV2Command MV2CommandsArray[] =
{
  { putPlay                          ,"play"},
  { putPause                         ,"Pause"},
  { putPlayPause                     ,"Play/Pause"},
  { putStop                          ,"Stop"},       
  { putRepeatOff                     ,"Repeat off"}, 
  { putRepeatTitle                   ,"Repeat title"},
  { putRepeatAll                     ,"Repeat all"},
  { putRepeatRandom                  ,"Repeat random"},
  { putNextRepeatMode                ,"next repeat mode"},
  { putRate01                        ,"rate 0.1"},
  { putRate025                       ,"rate 0.25"},
  { putRate05                        ,"rate 0.5"},
  { putRate075                       ,"rate 0.75"},
  { putRate1                         ,"rate 1"},
  { putRate125                       ,"rate 1.25"},
  { putRate15                        ,"rate 1.5"},
  { putRate2                         ,"rate 2"},
  { putRate25                        ,"rate 2.5"},

  { putJumpForward5                  ,"jump 5"},
  { putJumpForward10                 ,"jump 10"},
  { putJumpForward30                 ,"jump 30"},
  { putJumpBackward5                 ,"jump back 5"},
  { putJumpBackward10                ,"jump back 10"},
  { putJumpBackward30                ,"jump back 30"},
  { putFrameForward                  ,"frame forward"},
  { putFrameBackward                 ,"frame backward"},
  { putRewind                        ,"rewind"},

  { putLoopStart                     ,"loop start"},
  { putLoopStop                      ,"loop stop"},
  { putLoopClear                     ,"loop clear"},
  { putSetBookmark                   ,"set bookmark"},
  { putKeyframeForward               ,"keyframejump forward"},
  { putKeyframeBackward              ,"keyframejump backward"},
  { putUserJumpForward               ,"user jump forward"},
  { putUserJumpBackward              ,"user jump backward"},
  { putAB_Repeat                     ,"AB repeat (loop start/stop/clear)"},

  { putMuteOn                        ,"mute on"},
  { putMuteOff                       ,"mute off"},
  { putMuteOnOff                     ,"mute on/off"},
  { putVolumePlus                    ,"volume Plus"},
  { putVolumeMinus                   ,"volume Minus"},
  { putTTS_VolumePlus                ,"tts volume Plus"},
  { putTTS_VolumeMinus               ,"tts volume Minus"},
  { putRatePlus                      ,"rate Plus"},
  { putRateMinus                     ,"rate Minus"},
  { putDlgRate                       ,"dlg rate"},
  { putTTS_On                        ,"tts on"},
  { putTTS_Off                       ,"tts off"},
  { putTTS_OnOff                     ,"tts on/off"},
  { putSwitchWindowBorder            ,"window border on/off"},

  { putZoomPlus                      ,"zoom Plus"},
  { putZoomMinus                     ,"zoom Minus"},
  { putMoveLeft                      ,"move left"},
  { putMoveRight                     ,"move right"},
  { putMoveUp                        ,"move up"},
  { putMoveDown                      ,"move down"},
  { putCenterVideo                   ,"center"},
  { putAspRatioPlus                  ,"asp. ratio Plus"},
  { putAspRatioMinus                 ,"asp. ratio Minus"},
  { putDVD_AspRatioWide              ,"dvd wide"},
  { putDVD_AspRatioLetter            ,"dvd letterbox"},
  { putRestore                       ,"restore"},
  { putTopmostOn                     ,"topmost on"},
  { putTopmostOff                    ,"topmost off"},
  { putTopmostOnOff                  ,"topmost on/off"},
  { putScan_FitToWindow              ,"fit to window"},
  { putScan_FullHeight               ,"full height"},
  { putScan_155_1                    ,"scan 1.55:1"},
  { putScan_16_9                     ,"scan 16:9"},
  { putScan_205_1                    ,"scan 2:1"},
  { putScan_FullWidth                ,"full width"},
  { putScan_Pixel_Pixel              ,"pixel:pixel"},
  { putSwitch_Scan                   ,"switch scan"},
  { putScan_Reset                    ,"scan reset"},
  { putNextFullscreenMode            ,"next fullscreen mode"},
  { putFullscreenOn                  ,"fullscreen on"},
  
  { putFullscreenOnOff               ,"fullscreen on/off"},
  { putOffset_Subtitles1_Plus        ,"offset sub1 Plus"},
  { putOffset_Subtitles1_Minus       ,"offset sub1 Minus"},
  { putOffset_Subtitles1_Reset       ,"offset sub1 reset"},
  { putOffset_Subtitles2_Plus        ,"offset sub2 Plus"},
  { putOffset_Subtitles2_Minus       ,"offset sub2 Minus"},
  { putOffset_Subtitles2_Reset       ,"offset sub2 reset"},

  { putNextSubtitles1                ,"next sub1"},
  { putNextSubtitles2                ,"next sub2"},
  { putNextAudio                     ,"next audio"},
  { putAudio_Offset_Minus            ,"audio offset Plus"},
  { putAudio_Offset_Plus             ,"audio offset Minus"},
  { putAudio_Offset_Reset            ,"audio ofset reset"},
  { putSubtitles1_Up                 ,"sub1 up"},
  { putSubtitles1_Down               ,"sub1 down"},
  { putSubtitles2_Up                 ,"sub2 up"},
  { putSubtitles2_Down               ,"sub2 down"},
  { putPrev                          ,"prev"},
  { putNext                          ,"next"},
  { putNextTitle                     ,"next title"},
  { putPrevTitle                     ,"prev title"},
  { putPrevSet                       ,"prev set"},
  { putNextSet                       ,"next set"},
  { putAspRatio_Free                 ,"asp.ratio free"},
  { putAspRatio_4_3                  ,"asp. ratio 4:3"},
  { putAspRatio_16_9                 ,"asp.ratio 16:9"},
  { putAspRatio_Preffered            ,"asp. ratio preffered"},
  { putPG_MENU                       ,"page menu"},
  { putPG_CHAP                       ,"page chapters"},
  { putPG_SPEC                       ,"page specials"},
  { putPG_LANG                       ,"page languages"},
  { putPG_SUBT                       ,"page subtitles"},
  { putPG_CAST                       ,"page cast"},
  { putPG_PLAY                       ,"play main movie"},

  { putGenerateMenu                  ,"generate menu"},
  { putRemoveMenu                    ,"remove menu"},
  { putSubtitles1_Size_Plus          ,"sub1 size Plus"},
  { putSubtitles1_Size_Minus         ,"sub1 size Minus"},
  { putSubtitles2_Size_Plus          ,"sub2 size Plus"},
  { putSubtitles2_Size_Minus         ,"sub2 size Minus"},
  { putClosedCaptionsOn              ,"closed captions on"},
  { putClosedCaptionsOff             ,"closed captions off"},
  { putClosedCaptionsOnOff           ,"closed captions on/off"},

  { putShowDlgProp_VideoDecoder      ,"prop videodecoder"},
  { putShowDlgProp_AudioDecoder      ,"prop audiodecoder"},
  { putShowDlgProp_VideoRenderer     ,"prop videorenderer"},
  { putShowDlgProp_AudioRenderer     ,"prop audiorenderer"},
  { putVideo_Mode_Window             ,"mode window"},
  { putVideo_Mode_Desktop            ,"mode desktop"},

  { putShutdown_On                   ,"shutdown on"},
  { putShutdown_Off                  ,"shutdown off"},
  { putShutdown_Now                  ,"shutdown now"},
  { putCancel_Shutdown               ,"cancel shutdown"},

  { putTimeFormat_Elapsed            ,"timeformat elapsed"},
  { putTimeFormat_Remain             ,"timeformat remain"},
  { putTimeFormat_Clock              ,"timeformat clock"},
  { putSwitch_TimeFormat             ,"switch timeformat"},
  { putShowFramesOnOff                ,"frames on/off"},

  { putDlgOpenFile                   ,"dlg open file"},
  { putOpen_CD                       ,"open cd"},
  { putDlgSaveTitlesAsPlaylist       ,"save titles as pllist"},
  { putDlgSaveTitlesAsMV2            ,"save titles as mv2"},
  { putDlgOpenDir                    ,"open dir"},
  { putOpen_Audio_CD                 ,"open audio cd"},
  { putSaveMenu                      ,"save menu"},
  { putDlgAddSubtitles               ,"add subtitles"},
  { putDlgAddAudio                   ,"add audio"},

  { putDlgOptions                    ,"dlg options"},
  { putDlgPlaylist                   ,"dlg playlist"},
  { putDlgJumpToTime                 ,"dlg jump"},
  { putDlgLoopAdjust                 ,"dlg loop"},
  { putDlgCatalog                    ,"dlg catalog"},
  { putDlgFileInfo                   ,"dlg fileinfo"},
  { putDlgBookmarksEditor            ,"dlg bookmarks"},

  { putDlgSubtitles1Properties       ,"dlg sub1 props"},
  { putDlgSubtitles2Properties       ,"dlg sub2 props"},
  { putExit                          ,"exit"},
  { putMinimize                      ,"minimize"},
  { putRunStartupFile                ,"run startup file"},
  { putNextSkin                      ,"next skin"},
  { putRandomInPlaylistOnly          ,"random in pllist"},
  { putRepeatAllInPlaylistOnly       ,"repeat in pllist"},
  { putPrevSkin                      ,"prev skin"},
  { putHomepage                      ,"homepage"},

  { putOSD_Menu                      ,"osd menu"},
  { putOSD_VK_UP                     ,"osd key up"},
  { putOSD_VK_DOWN                   ,"osd key down"},
  { putOSD_VK_LEFT                   ,"osd key left"},
  { putOSD_VK_RIGHT                  ,"osd key right"},
  { putOSD_Return                    ,"osd key enter"},
  { putOSD_Cancel                    ,"osd key esc"},

  { putOSD_Info                      ,"osd info"},

  { putOverlayMixerOn                ,"overlay mixer on"},
  { putOverlayMixerOff               ,"overlay mixer off"},
  { putOverlayMixerOnOff             ,"overlay mixer on/off"},
  { putRestartGraph                  ,"restart graph"},

  { putOverlay_Brightness_Minus      ,"ovr brightness Minus"},
  { putOverlay_Brightness_Plus       ,"ovr brightness Plus"},
  { putOverlay_Contrast_Minus        ,"ovr contrast Minus"},
  { putOverlay_Contrast_Plus         ,"ovr contrast Plus"},
  { putOverlay_Hue_Minus             ,"ovr hue Minus"},
  { putOverlay_Hue_Plus              ,"ovr hue Plus"},
  { putOverlay_Saturation_Minus      ,"ovr saturation Minus"},
  { putOverlay_Saturation_Plus       ,"ovr saturation Plus"},
  { putOverlay_Sharpness_Minus       ,"ovr sharp inus"},
  { putOverlay_Sharpness_Plus        ,"ovr sharp Plus"},
  { putOverlay_Gamma_Minus           ,"ovr gamma Minus"},
  { putOverlay_Gamma_Plus            ,"ovr gamma Plus"},
                                      
  { putSwitchSkinSize                ,"switch skin size"},
                                    
  { putQuality_Minus                 ,"quality Minus"},
  { putQuality_Plus                  ,"quality Plus"},
  { putBrightness_Minus              ,"brightness Minus"},
  { putBrightness_Plus               ,"brightness Plus"},
  { putContrast_Minus                ,"contrast Minus"},
  { putContrast_Plus                 ,"contrast Plus"},
  { putSaturation_Minus              ,"saturation Minus"},
  { putSaturation_Plus               ,"saturation Plus"},
  { putGamma_Minus                   ,"gamma Minus"},
  { putGamma_Plus                    ,"gamma Plus"},
                                      
  { putDedynamic_OnOff               ,"dedynamic on/off"},
  { putTFMAudio_OnOff                ,"tfm audio on/off"},
                                      
  { putPlayerBarHide                 ,"player bar hide"},
  { putPlayerBarShow                 ,"player bar show"},
  { putPlayerBarShowHide             ,"player bar on/off"},
  { putCaptureFrame                  ,"capture frame"},
  { putClearBookmarks                ,"clear bookmarks"},

  { putDefault_Brightness            ,"def brightness"},
  { putDefault_Contrast              ,"def contrast"},
  { putDefault_Saturation            ,"def saturation"},
  { putDefault_Noise                 ,"def noise"},
  { putDefault_Sharpness             ,"def sharpness"},
  { putDefault_Gamma                 ,"def gamma"},

  { XputSetPosition                 ,"*set position rel."},  // +value
  { XputRunTitleRel                 ,"*run title rel."},     // +value
  { XputSetVolume                   ,"*set volume"},         // +value
  { XputSetBalance                  ,"*set balance"},        // +value
  { XputSetTTSVolume                ,"*set tts volume"},     // +value
  
  { putDlgComicsCreator              ,"dlg comics creator"},
  { putClearAllRecents               ,"clear recents"},
  { putUser_Aspect_Ratio             ,"user asp. ratio"},
  { putUser_Scan                     ,"user scan"},
  { putCD_TrayOpen                   ,"cd tray open"},
  { putCD_TrayClose                  ,"cd tray close"},
                                      
  { putExport_GXR                    ,"dlg export gxr"},
  { putExport_GML                    ,"dlg export gml"},
  
  { putPad1_OnOff                    ,"pad1 on/off"},
  { putPad2_OnOff                    ,"pad2 on/off"},
  { putPad3_OnOff                    ,"pad3 on/off"},
  { putPad4_OnOff                    ,"pad4 on/off"},
  { putCover1_OnOff                  ,"cover 1 on/off"},
  { putCover2_OnOff                  ,"cover 2 on/off"},
  { putCover3_OnOff                  ,"cover 3 on/off"},
  { putCover4_OnOff                  ,"cover 4 on/off"},

  { XputRunTitle                     ,"*run title"},  

  { putNum0                          ,"num 0"},
  { putNum1                          ,"num 1"},
  { putNum2                          ,"num 2"},
  { putNum3                          ,"num 3"},
  { putNum4                          ,"num 4"},
  { putNum5                          ,"num 5"},
  { putNum6                          ,"num 6"},
  { putNum7                          ,"num 7"},
  { putNum8                          ,"num 8"},
  { putNum9                          ,"num 9"},
  { putNum10                         ,"num 10"},

  { putSlot1_Save                    ,"slot 1 save"},
  { putSlot1_Load                    ,"slot 1 load"},
  { putSlot2_Save                    ,"slot 2 save"},
  { putSlot2_Load                    ,"slot 2 load"},
  { putSlot3_Save                    ,"slot 3 save"},
  { putSlot3_Load                    ,"slot 3 load"},
  { putSlot4_Save                    ,"slot 4 save"},
  { putSlot4_Load                    ,"slot 4 load"},
  { putSlot5_Save                    ,"slot 5 save"},
  { putSlot5_Load                    ,"slot 5 load"},

  { putStopSet                       ,"stop set"},
  { putStopAndClearPlaylist          ,"stop and clear playlist"},
  
  { XputRunChapterNr                 ,"run chapter nr."},

  { 0, " >>> end marker" }
};


//
//
// GetStatus 
//
//

const TMV2Command MV2GetStatusArray[] =
{
  { getPlayStatus                 ,"play status"},  // 1=playing 2=paused 3=stopped 4=rewind
  { getRepeatMode                 ,"repeat mode"},  // 1=off 2=repeatTitle 3=repeatAll 4=randomMode
  { getRate                       ,"rate"},         // 100 = 1x,""}, 50=0.5x ....
  { getLooping                    ,"looping"},      // 1=loop active

  { getMute                       ,"mute"},         // 1=mutted
  { getTTS                        ,"tts"},

  { getBorder                     ,"border"},       // 1=border on

  { getTopmost                    ,"topmost"},
  { getVideoMode                  ,"video mode"},   // 1=Window 2=Fullscreen 3=Desktop

  { getOffsetSubtitles1           ,"offset sub1"},  // [frames]
  { getOffsetSubtitles2           ,"offset sub2"},  // [frames]
  { getAudioOffset                ,"offset audio"}, // [msec]

  { getSubtitles1Nr               ,"sub1 nr"},
  { getSubtitles2Nr               ,"sub2 nr"},
  { getAudioNr                    ,"audio nr"},

  { getSubtitles1position         ,"sub1 pos"},     // 0=bottom, 100=top [%]
  { getSubtitles2position         ,"sub2 pos"},     // 0=bottom, 100=top [%]

  { getSubtitles1size             ,"sub1 size"},
  { getSubtitles2size             ,"sub2 size"},

  { getClosedCaptions             ,"closed captions"},// 1=DVD closed captions on

  { getShutdown                   ,"shutdown"},       // 1= shutdown on 

  { getTimeMode                   ,"time mode"},      // 1=elapsed 2=remain 3=clock
  { getModeFrames                 ,"mode frames"},    // 1=show frames

  { getDlgOptions                 ,"dlg options"},
  { getDlgPlaylist                ,"dlg playlist"},
  { getDlgJumpToTime              ,"dlg jump"},
  { getDlgLoop                    ,"dlg loop"},
  { getDlgCatalog                 ,"dlg catalog"},
  { getDlgFileInfo                ,"dlg fileinfo"},
  { getDlgBookmarks               ,"dlg bookmarks"},
  { getDlgSubtitles1              ,"dlg sub1"},
  { getDlgSubtitles2              ,"dlg sub2"},

  { getMinimized                  ,"minimized"},

  { getRandom_in_playlist_only    ,"random in playlist"},
  { getRepeatAll_in_playlist_only ,"repeat in playlist"},

  { getOSD_Menu                   ,"osd menu"},     // 1=visible
  { getOSD_Info                   ,"osd info"},     // 1=visible

  { getOverlay_Mixer              ,"ovr mixer"},    // 1=active
  { getDedynamic                  ,"dedynamic"},
  { getTFM_Audio                  ,"tfm audio"},
                                      
  { getPlayerBar                  ,"player bar"},   // 1=visible

  { getPosition                   ,"position"},     // 0-100 [%]
  { getVolume                     ,"volume"},       // 0-100 [%]
  { getBalance                    ,"balance"},      // 0 = left, 100=right, 50=center

  { getBrightness                 ,"brightness"},   // 0-100 [%]
  { getContrast                   ,"contrast"},     // 0-100 [%]
  { getSaturation                 ,"saturation"},   // 0-100 [%]
  { getNoise                      ,"noise"},        // 0-100 [%]
  { getSharpness                  ,"sharpness"},    // 0-100 [%]
  { getGamma                      ,"gamma"},        // 0-100 [%]

  { getPad1                       ,"pad1"},
  { getPad2                       ,"pad2"},
  { getPad3                       ,"pad3"},
  { getPad4                       ,"pad4"},
  { getCover1                     ,"cover1 opened"},
  { getCover2                     ,"cover2 opened"},
  { getCover3                     ,"cover3 opened"},
  { getCover4                     ,"cover4 opened"},

  { 0, " >>> end marker" }
};





/////////////////////////////////////////////////////////////////////////////
// CMV2Command_VCDlg dialog

CMV2Command_VCDlg::CMV2Command_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMV2Command_VCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMV2Command_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMV2Command_VCDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_STOP,      OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_PLAY,      OnButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_EXIT,      OnButtonExit)

  ON_BN_CLICKED(IDC_BUTTON0,          OnButton0)
  ON_BN_CLICKED(IDC_BUTTON1,          OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2,          OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3,          OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4,          OnButton4)
  ON_BN_CLICKED(IDC_BUTTON5,          OnButton5)
  ON_BN_CLICKED(IDC_BUTTON6,          OnButton6)
  ON_BN_CLICKED(IDC_BUTTON7,          OnButton7)
  ON_BN_CLICKED(IDC_BUTTON8,          OnButton8)
  ON_BN_CLICKED(IDC_BUTTON9,          OnButton9)

  ON_BN_CLICKED(IDC_BUTTON_EJECT_CD,  OnButtonEjectCD)
  ON_BN_CLICKED(IDC_BUTTON_CLOSE_CD,  OnButtonCloseCD)

  ON_BN_CLICKED(IDC_BUTTON_HIDE_BAR,  OnButtonHideBar)
  ON_BN_CLICKED(IDC_BUTTON_SHOW_BAR,  OnButtonShowBar)

  ON_BN_CLICKED(IDC_BUTTON_SEND,      OnButtonSend)  
  ON_BN_CLICKED(IDC_BUTTON_GETSTATUS, OnButtonGetStatus)  
  ON_BN_CLICKED(IDC_BUTTON_CLEAR,     OnButtonClear)  
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMV2Command_VCDlg message handlers

//-------------------------------------------------------
BOOL CMV2Command_VCDlg::OnInitDialog()
//-------------------------------------------------------
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  FillCombo();
  FillComboStatus();

  InitNotify();
  SetAutoNotify(true);  

	return TRUE;  // return TRUE  unless you set the focus to a control
}

//-------------------------------------------------------
void CMV2Command_VCDlg::FillCombo()
//-------------------------------------------------------
{
  CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_COMMANDS);
  if (!pCombo) 
    return;

  int i=0;
  while (MV2CommandsArray[i].ID)
  {
    pCombo->AddString(MV2CommandsArray[i].cDesc); 
    pCombo->SetItemData(i, MV2CommandsArray[i].ID);
    i++;
  }
  pCombo->SelectString(0, "play");
}

//-------------------------------------------------------
void CMV2Command_VCDlg::FillComboStatus()
//-------------------------------------------------------
{
  CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_GETSTATUS);
  if (!pCombo) 
    return;

  int i=0;
  while (MV2GetStatusArray[i].ID)
  {
    pCombo->AddString(MV2GetStatusArray[i].cDesc); 
    pCombo->SetItemData(i, MV2GetStatusArray[i].ID);
    i++;
  }
  pCombo->SelectString(0, "play status");
}

//-------------------------------------------------------
void CMV2Command_VCDlg::OnPaint() 
//-------------------------------------------------------
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//-------------------------------------------------------
HCURSOR CMV2Command_VCDlg::OnQueryDragIcon()
//-------------------------------------------------------
{
	return (HCURSOR) m_hIcon;
}

//-------------------------------------------------------
int CMV2Command_VCDlg::Send(int wPar, int lPar, bool bPost/*=true*/)
//-------------------------------------------------------
{
  HWND Mv2Handle=::FindWindow("MV2 Player", NULL);

  if (Mv2Handle)
  {
    if (bPost)
    {
      ::PostMessage(Mv2Handle, WM_COMMAND, wPar, lPar);
      return 0;
    }
    else
      return::SendMessage(Mv2Handle, WM_COMMAND, wPar, lPar);
  }
  AfxMessageBox("MV2Player not running");
  return -1;
}

//-------------------------------------------------------
void CMV2Command_VCDlg::InitNotify()
//-------------------------------------------------------
{
  // set handle for autonotify and results of MV2GetStatusPost
  int lPar = PUT_NOTIFY_HANDLE;
  int wPar = (int)GetSafeHwnd(); // this window
  Send(wPar, lPar);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::SetAutoNotify(bool bAutonotify)
//-------------------------------------------------------
{
  /// all actions from mv2player will be send (or not) to handle from InitNotify
  int lPar = PUT_AUTONOTIFY;
  int wPar = bAutonotify ? 1:0;
  Send(wPar, lPar);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::MV2Command(int Command, int Value/*=0*/)
//-------------------------------------------------------
{
  int lPar = PUT_COMMAND_EX;
  Send(Value, MAKELONG(lPar, Command));
}

//-------------------------------------------------------
void CMV2Command_VCDlg::MV2GetStatusPost(int wPar)
//-------------------------------------------------------
{
  int lPar = GET_STATUS;
  Send(wPar, lPar);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::MV2GetStatus(int wPar)
//-------------------------------------------------------
{
  int lPar = GET_STATUS;
  int iRes = Send(wPar, lPar, false);
  if (iRes>=0)
    ProcessResult(wPar, iRes);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::OnButtonSend() 
//-------------------------------------------------------
{
  CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_COMMANDS);
  if (!pCombo) 
    return;

  int idx = pCombo->GetCurSel();
  if (idx<0) return;
  
  CEdit* pEdit = (CEdit*)GetDlgItem(IDC_EDIT_VALUE);
  CString str;
  pEdit->GetWindowText(str);

  int Value = atoi(str);

  MV2Command(pCombo->GetItemData(idx), Value);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::OnButtonGetStatus() 
//-------------------------------------------------------
{
  CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_GETSTATUS);
  if (!pCombo) 
    return;

  int idx = pCombo->GetCurSel();
  if (idx<0) return;
  
  MV2GetStatus(pCombo->GetItemData(idx));
//  MV2GetStatusPost(pCombo->GetItemData(idx));
}

//-------------------------------------------------------
void CMV2Command_VCDlg::OnButtonClear() 
//-------------------------------------------------------
{
  CListBox* pLB = (CListBox*)GetDlgItem(IDC_LIST_ACTIONS);
  if (pLB)
    pLB->ResetContent();
}

//-------------------------------------------------------
void CMV2Command_VCDlg::ProcessResult(int Command, int Value)
//-------------------------------------------------------
{
  char buffer[20];
  _itoa( Value, buffer, 10);
  CString sResult = buffer;

  switch (Command)
  {
  case getPosition : 
    {
      sResult = "Position "+sResult+" %";
      CWnd* pStatus = GetDlgItem(IDC_STATIC_POSITION);
      if (pStatus)
      {
        pStatus->SetWindowText(sResult);
      }
      return;
    }

  case getPlayStatus : 
    switch (Value)
    {
    case 1: sResult = "Playing";break;
    case 2: sResult = "Paused"; break;
    case 3: sResult = "Stopped"; break;
    case 4: sResult = "Rewind"; break;
    }
    break; 
  }

  CWnd* pStatus = GetDlgItem(IDC_STATIC_RESULT);
  if (pStatus)
    pStatus->SetWindowText(sResult);
}

//-------------------------------------------------------
void CMV2Command_VCDlg::ProcessNotify(int Command, int Value)
//-------------------------------------------------------
{
  CString sResult = "";

  CString sCommand = "unknown";
  char buffer[20];
  _itoa( Command, buffer, 10);
  CString sCommandId = buffer; // command ID

  // convert command code to description
  int i=0;
  while (MV2CommandsArray[i].ID)
  {
    if (MV2CommandsArray[i].ID == Command)
    {
      sCommand = MV2CommandsArray[i].cDesc; 
      break;
    }
    i++;
  }

  _itoa( Value, buffer, 10);
  CString sValue = buffer;


  CListBox* pLB = (CListBox*)GetDlgItem(IDC_LIST_ACTIONS);
  if (pLB)
    pLB->AddString("Cmd="+sCommandId+" ("+sCommand+") value="+sValue);
}

//-------------------------------------------------------
BOOL CMV2Command_VCDlg::OnCommand(WPARAM wParam, LPARAM lParam)
//-------------------------------------------------------
{
  if (LOWORD(lParam) == ACTION_NOTIFY)  // if Autonotify
  {
    int iCode = HIWORD(lParam);
    int iValue = wParam; 

    ProcessNotify(iCode, iValue);  

    return TRUE;
  }

  if (LOWORD(lParam) == GET_STATUS)  // if used PostMessage
  {
    int iCode = HIWORD(lParam);
    int iValue = wParam; 

    ProcessResult(iCode, iValue);  

    return TRUE;
  }

  return CWnd::OnCommand(wParam, lParam);
}

